
addItemAddr	equ	guiListVars
lcurRow		equ	guiListVars+2
totalItems	equ	guiListVars+3
listSelect 	equ	guiListVars+2	; CHANGE!!!

listFlags	equ	asm_Flag1
singleSel	equ	00h
dispType		equ	01h

StartList:
 pop		hl							; We firstly need the addr
 ex		de,hl						; of the function that adds
 ld		a,(de)					; items to the list. This
 ld		l,a						; is what we are retrieving
 inc		de							; here.
 ld		a,(de)					;
 ld		h,a						;
 ld		(addItemAddr), hl		; Store address
 ld		a,1						; List cursor starts at top
 ld		(lcurRow),a				; Store position

 ld		hl,0001h
 ld		(curRow),hl
 xor		a							; First item
 push		af							; Remember accumulator
 GuiListAddItem Test				; Are there any items?
 jr		c,dl1						; If not, skip to read the keys
 ld		b,7						; Only seven items on the screen
DrawList:
 ld		a,20h						; Draw a space
 B_CALL	PutC						;
 ld		a,20h						; Draw a space
 B_CALL	PutC						;
 ld		hl, OP1+1				; String starts at OP1+1
 call		DrawString				; Draw the string (destroys OP1)
 B_CALL	EraseEOL					; Erase the line
 jr		c,dl0						; If NewLine not needed, skip
 B_CALL	NewLine					; Move to next line
dl0:									;
 B_CALL	OP3ToOP1					; Retrieve program name 
 pop		af							; Restore accumulator
 inc		a							; Increment the count
 ld		(totalItems),a			; Store
 push		af							; Remember accumulator
 push		bc							; Remember byte count
 GuiListAddItem AddLoop			; Add an item
 jr		c,dl1						; If an early exit is required...
 pop		bc
 djnz		DrawList					; Otherwise loop

dl1:									;
 ld		a,(lcurRow)				; Check the list cursor row
 ld		l,a						; Load to L
 ld		h,0						; Load 0 to H
 ld		(curRow),hl				; Load into curRow
 ld		a,05h						; A non-selected cursor
 B_CALL	PutC						; Draw the character

KeyLoop:
 B_CALL	GetKey
 cp		kDown
 jr		z,CurDown
 cp		kUp
 jr		z,CurUp
 cp		kLeft
 jp		z, GuiHeadLeft
 cp		kRight 
 jp		z, GuiHeadRight
 cp		kClear
 jp		z, Exit
 cp		kQuit
 jp		z, Exit
 jr		KeyLoop

CurDown:
 ld		a,(totalItems)
 cp		7
 jp		m,cd1
 ld		b,7
cd1:
 ld		b,a
 ld		a,(lcurRow)
 cp		b
 jr		z,cd0
 call		EraseCursor
 inc		l
 ld		a,l
 ld		(curRow),hl
 ld		(lcurRow),a
 ld		a,05h
 B_CALL	PutMap
cd0:
 jr		KeyLoop

CurUp:
 ld		a,(lcurRow)				; Load acc with cur position
 cp		1							; If at the top
 jr		z,cu1						; Either stop, or scroll
 call		EraseCursor				; Erase the old cursor
 dec		l							; Decrease the position
 ld		a,l						; Load in the acc
 ld		(curRow),hl				; Load into cursor position
 ld		(lcurRow),a				; Load into list cursor
 ld		a,05h						; ">" character
 B_CALL	PutMap					; Display
cu1:									;
 jr		KeyLoop					;

EraseCursor:						;
 ld		a,(lcurRow)				; Load the current cursor
 ld		h,0						; coordinates and store them
 ld		l,a						; in HL
 ld		(curRow),hl				; Load into curRow
 ld		a,20h						; Space character
 B_CALL	PutMap					; Draw a space (erase the arrow)
 ret									; Return

